#### Accuracy of Smartphone and External Handheld GPS Receivers #### 
#### November 2023 ####
#### LWM ewsn Spot Survey Data ####
############################################

setwd("~/Desktop/PC_Folders/LHB/Manuscripts/GPS_Calibration/GPSCalibration_SupplementalData/GPS_Data_Processing/GPX_Data")
list.files()
list.files(pattern=".gpx")

library(XML)
library(ggplot2)
library(scales)
#library(ggforce)
library(sp)

#from Trimble data with Wilton-Jones transformation
x= -2.4748789803808
y= 53.450914719012

#Deduce Lat difference for 2m radius on y axis
Y=data.frame(x,y+0.000009)
Y <-as.matrix(Y)
1000*(spDistsN1(pts=Y,pt=c(x,y),longlat=TRUE))
ymin=y-(2*0.0000090);ymin#
ymax=y+(2*0.0000090);ymax#

#Deduce Lon difference for 2m radius on x axis
X=data.frame(x+0.0000151,y)
X <-as.matrix(X)
1000*(spDistsN1(pts=X,pt=c(x,y),longlat=TRUE))
xmin=x-(2*0.0000151);xmin#
xmax=x+(2*0.0000151);xmax#


list.files(pattern="2023-11-21")

BES_P1.gpx <- htmlTreeParse(file = "2023-11-21 12_44_07 point BES.gpx", useInternalNodes = TRUE)
BES_P1.coords <- xpathSApply(doc = BES_P1.gpx, path = "//trkpt", fun = xmlAttrs)
BES_P.1.df <- data.frame(Repeat=1, Date=211123,Receiver="BES",
  lon = as.numeric(BES_P1.coords["lon", ]),
  lat = as.numeric(BES_P1.coords["lat",]))
ggplot(data=BES_P.1.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
  
####
BELC_P1.gpx <- htmlTreeParse(file = "2023-11-21 12_44_13 point BELC.gpx", useInternalNodes = TRUE)
BELC_P1.coords <- xpathSApply(doc = BELC_P1.gpx, path = "//trkpt", fun = xmlAttrs)
BELC_P.1.df <- data.frame(Repeat=1, Date=211123,
Receiver="BELC",
      lon = as.numeric(BELC_P1.coords["lon", ]),
      lat = as.numeric(BELC_P1.coords["lat",])
    )
ggplot(data=BELC_P.1.df, aes(x=lon, y=lat))+geom_jitter()  + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####
iP12_P.1.gpx <- htmlTreeParse(file = "2023-11-21 12_44_15 point iPhone 12.gpx", useInternalNodes = TRUE)
iP12_P.1.coords <- xpathSApply(doc = iP12_P.1.gpx, path = "//trkpt", fun = xmlAttrs)
iP12_P.1.df <- data.frame(Repeat=1, Date=211123,
Receiver="iP12",
      lon = as.numeric(iP12_P.1.coords["lon", ]),
      lat = as.numeric(iP12_P.1.coords["lat",])
    )
ggplot(data=iP12_P.1.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####
iP6_P.1.gpx <- htmlTreeParse(file = "2023-11-21 12_43_36 point iPhone 6.gpx", useInternalNodes = TRUE)
iP6_P.1.coords <- xpathSApply(doc = iP6_P.1.gpx, path = "//trkpt", fun = xmlAttrs)
iP6_P.1.df <- data.frame(Repeat=1, Date=211123,
Receiver="iP6",
      lon = as.numeric(iP6_P.1.coords["lon", ]),
      lat = as.numeric(iP6_P.1.coords["lat",])
    )
ggplot(data=iP6_P.1.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
########
list.files(pattern="2023-11-24")

BES_P2.gpx <- htmlTreeParse(file = "2023-11-24 13_47_07 point BES.gpx", useInternalNodes = TRUE)
BES_P2.coords <- xpathSApply(doc = BES_P2.gpx, path = "//trkpt", fun = xmlAttrs)
BES_P.2.df <- data.frame(Repeat=2, Date=241123,Receiver="BES",
                      lon = as.numeric(BES_P2.coords["lon", ]),
                      lat = as.numeric(BES_P2.coords["lat",]))
ggplot(data=BES_P.2.df, aes(x=lon, y=lat))+geom_point(cex=0.25) + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")



####
BELC_P2.gpx <- htmlTreeParse(file = "2023-11-24 13_47_07 point BELC.gpx", useInternalNodes = TRUE)
BELC_P2.coords <- xpathSApply(doc = BELC_P2.gpx, path = "//trkpt", fun = xmlAttrs)
BELC_P.2.df <- data.frame(Repeat=2, Date=241123,
                       Receiver="BELC",
                       lon = as.numeric(BELC_P2.coords["lon", ]),
                       lat = as.numeric(BELC_P2.coords["lat",]))
ggplot(data=BELC_P.2.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")


####
iP12_P.2.gpx <- htmlTreeParse(file = "2023-11-24 13_47_07 point iPhone 12.gpx", useInternalNodes = TRUE)
iP12_P.2.coords <- xpathSApply(doc = iP12_P.2.gpx, path = "//trkpt", fun = xmlAttrs)
iP12_P.2.df <- data.frame(Repeat=2, Date=241123,
                        Receiver="iP12",
                        lon = as.numeric(iP12_P.2.coords["lon", ]),
                        lat = as.numeric(iP12_P.2.coords["lat",]))
ggplot(data=iP12_P.2.df, aes(x=lon, y=lat))+geom_point() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")


####
iP6_P.2.gpx <- htmlTreeParse(file = "2023-11-24 13_47_04 point iPhone 6.gpx", useInternalNodes = TRUE)
iP6_P.2.coords <- xpathSApply(doc = iP6_P.2.gpx, path = "//trkpt", fun = xmlAttrs)
iP6_P.2.df <- data.frame(Repeat=2, Date=241123,
                       Receiver="iP6",
                       lon = as.numeric(iP6_P.2.coords["lon", ]),
                       lat = as.numeric(iP6_P.2.coords["lat",]))
ggplot(data=iP6_P.2.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")

########
list.files(pattern="2023-11-25")

BES_P3.gpx <- htmlTreeParse(file = "2023-11-25 14_26_43 point BES.gpx", useInternalNodes = TRUE)
BES_P3.coords <- xpathSApply(doc = BES_P3.gpx, path = "//trkpt", fun = xmlAttrs)
BES_P.3.df <- data.frame(Repeat=3, Date=251123,
      Receiver="BES",
      lon = as.numeric(BES_P3.coords["lon", ]),
      lat = as.numeric(BES_P3.coords["lat",]))
ggplot(data=BES_P.3.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####

BELC_P3.gpx <- htmlTreeParse(file = "2023-11-25 14_26_39 point BELC.gpx", useInternalNodes = TRUE)
BELC_P3.coords <- xpathSApply(doc = BELC_P3.gpx, path = "//trkpt", fun = xmlAttrs)
BELC_P.3.df <- data.frame(Repeat=3, Date=251123,
Receiver="BELC",
      lon = as.numeric(BELC_P3.coords["lon", ]),
      lat = as.numeric(BELC_P3.coords["lat",]))
ggplot(data=BELC_P.3.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####

iP12_P.3.gpx <- htmlTreeParse(file = "2023-11-25 14_26_41 point iPhone12.gpx", useInternalNodes = TRUE)
iP12_P.3.coords <- xpathSApply(doc = iP12_P.3.gpx, path = "//trkpt", fun = xmlAttrs)
iP12_P.3.df <- data.frame(Repeat=3, Date=251123,
Receiver="iP12",
      lon = as.numeric(iP12_P.3.coords["lon", ]),
      lat = as.numeric(iP12_P.3.coords["lat",]))
ggplot(data=iP12_P.3.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####

iP6_P.3.gpx <- htmlTreeParse(file = "2023-11-25 14_26_38 point iPhone6.gpx", useInternalNodes = TRUE)
iP6_P.3.coords <- xpathSApply(doc = iP6_P.3.gpx, path = "//trkpt", fun = xmlAttrs)
iP6_P.3.df <- data.frame(Repeat=3, Date=251123,
Receiver="iP6",
      lon = as.numeric(iP6_P.3.coords["lon", ]),
      lat = as.numeric(iP6_P.3.coords["lat",]))
ggplot(data=iP6_P.3.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")

####

list.files(pattern="2023-11-26")

BES_P4.gpx <- htmlTreeParse(file = "2023-11-26 14_33_56 point BES.gpx", useInternalNodes = TRUE)
BES_P4.coords <- xpathSApply(doc = BES_P4.gpx, path = "//trkpt", fun = xmlAttrs)
BES_P.4.df <- data.frame(Repeat=4, Date=251126,
                      Receiver="BES",
                      lon = as.numeric(BES_P4.coords["lon", ]),
                      lat = as.numeric(BES_P4.coords["lat",]))
ggplot(data=BES_P.4.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")

####

BELC_P4.gpx <- htmlTreeParse(file = "2023-11-26 14_33_54 point BELC.gpx", useInternalNodes = TRUE)
BELC_P4.coords <- xpathSApply(doc = BELC_P4.gpx, path = "//trkpt", fun = xmlAttrs)
BELC_P.4.df <- data.frame(Repeat=4, Date=251126,
                       Receiver="BELC",
                       lon = as.numeric(BELC_P4.coords["lon", ]),
                       lat = as.numeric(BELC_P4.coords["lat",]))
ggplot(data=BELC_P.4.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")

####

iP12_P.4.gpx <- htmlTreeParse(file = "2023-11-26 14_33_55 point iPhone12.gpx", useInternalNodes = TRUE)
iP12_P.4.coords <- xpathSApply(doc = iP12_P.4.gpx, path = "//trkpt", fun = xmlAttrs)
iP12_P.4.df <- data.frame(Repeat=4, Date=251126,
                        Receiver="iP12",
                        lon = as.numeric(iP12_P.4.coords["lon", ]),
                        lat = as.numeric(iP12_P.4.coords["lat",]))
ggplot(data=iP12_P.4.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")

####

iP6_P.4.gpx <- htmlTreeParse(file = "2023-11-26 14_33_53 point iPhone6.gpx", useInternalNodes = TRUE)
iP6_P.4.coords <- xpathSApply(doc = iP6_P.4.gpx, path = "//trkpt", fun = xmlAttrs)
iP6_P.4.df <- data.frame(Repeat=4, Date=251126,
                       Receiver="iP6",
                       lon = as.numeric(iP6_P.4.coords["lon", ]),
                       lat = as.numeric(iP6_P.4.coords["lat",]))
ggplot(data=iP6_P.4.df, aes(x=lon, y=lat))+geom_jitter() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")

####

list.files(pattern="2023-11-28")

BES_P5.gpx <- htmlTreeParse(file = "2023-11-28 15_17_10 point BES.gpx", useInternalNodes = TRUE)
BES_P5.coords <- xpathSApply(doc = BES_P5.gpx, path = "//trkpt", fun = xmlAttrs)
BES_P.5.df <- data.frame(Repeat=5, Date=281123,
                      Receiver="BES",
                      lon = as.numeric(BES_P5.coords["lon", ]),
                      lat = as.numeric(BES_P5.coords["lat",]))
ggplot(data=BES_P.5.df, aes(x=lon, y=lat))+geom_point()  + 
  scale_x_continuous(limits = c(-2.474950,-2.474850))+
  scale_y_continuous(limits = c(53.450850,53.450950)) + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####

BELC_P5.gpx <- htmlTreeParse(file = "2023-11-28 15_17_08 point BELC.gpx", useInternalNodes = TRUE)
BELC_P5.coords <- xpathSApply(doc = BELC_P5.gpx, path = "//trkpt", fun = xmlAttrs)
BELC_P.5.df <- data.frame(Repeat=5, Date=281123,
                       Receiver="BELC",
                       lon = as.numeric(BELC_P5.coords["lon", ]),
                       lat = as.numeric(BELC_P5.coords["lat",]))
ggplot(data=BELC_P.5.df, aes(x=lon, y=lat))+geom_point() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####

iP12_P.5.gpx <- htmlTreeParse(file = "2023-11-28 15_17_10 point iPhone 12.gpx", useInternalNodes = TRUE)
iP12_P.5.coords <- xpathSApply(doc = iP12_P.5.gpx, path = "//trkpt", fun = xmlAttrs)
iP12_P.5.df <- data.frame(Repeat=5, Date=281123,
                        Receiver="iP12",
                        lon = as.numeric(iP12_P.5.coords["lon", ]),
                        lat = as.numeric(iP12_P.5.coords["lat",]))
ggplot(data=iP12_P.5.df, aes(x=lon, y=lat))+geom_point() + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####

iP6_P.5.gpx <- htmlTreeParse(file = "2023-11-28 15_17_07 point iPhone 6.gpx", useInternalNodes = TRUE)
iP6_P.5.coords <- xpathSApply(doc = iP6_P.5.gpx, path = "//trkpt", fun = xmlAttrs)
iP6_P.5.df <- data.frame(Repeat=5, Date=281123,
                       Receiver="iP6",
                       lon = as.numeric(iP6_P.5.coords["lon", ]),
                       lat = as.numeric(iP6_P.5.coords["lat",]))
ggplot(data=iP6_P.5.df, aes(x=lon, y=lat))+geom_jitter(height=0.000001,width=0.000001) + 
  annotate("pointrange", x = x, y = y, 
           ymin = ymin, ymax = ymax,
           colour = "red", size = 0.5)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.4,colour="red")
####################################################
##Analysis##
##############
##Merge data
#options(digits=9)
#options(scipen=999)
EWSN_R <-rbind(BES_P.1.df,BELC_P.1.df,iP12_P.1.df,iP6_P.1.df,
            BES_P.2.df,BELC_P.2.df,iP12_P.2.df,iP6_P.2.df,
            BES_P.3.df,BELC_P.3.df,iP12_P.3.df,iP6_P.3.df,
            BES_P.4.df,BELC_P.4.df,iP12_P.4.df,iP6_P.4.df,
            BES_P.5.df,BELC_P.5.df,iP12_P.5.df,iP6_P.5.df)
nrow(EWSN_R)


ggplot(data=EWSN_R, aes(x=lon, y=lat))+ geom_jitter(width=0.000003,height=0.000003,size=0.3,aes(colour=Receiver))+
  theme_bw()+
  annotate("pointrange", x = x, y = y, 
           ymin = ymin , ymax = ymax,
           colour = "red", size = 0.75)+
  geom_segment(x=xmin, y=y, xend=xmax, yend=y,size=0.45,colour="red")+
  annotate(geom="text", x = -2.47490, y = 53.450896, 
           label="Radius = 1 m", angle=0,
           colour = "red")+
  annotate(geom="text", x = -2.474860, y = 53.450905, 
           label="Reference Point ewsn", angle=0,
           colour = "red")

##Distance(m)
library(sp)

Measurements_P <- matrix(c(EWSN_R$lon,EWSN_R$lat),ncol=2)
head(Measurements_P)
nrow(Measurements_P)
#Calc Distance from base station (m) from lon-lat data (WSG84)
EWSN_R.dist <-1000*(spDistsN1(pts=Measurements_P,
                           pt=c(x,y), 
                           longlat=TRUE))
range(EWSN_R.dist)
class(EWSN_R.dist)

EWSN_R$Dist <-EWSN_R.dist

boxplot(Dist~Receiver, data=EWSN_R,
        ylab="Radial Distance (m)")

##Density plot
names(EWSN_R) 
ggplot(EWSN_R, aes(x=Dist, colour=Receiver,fill=Receiver)) + xlab("Distance (m)")+
  geom_density(alpha=0.4)+theme_bw()+
  geom_segment(x=1, y=-0.07, xend=1, yend=2,size=0.05,colour="black",linetype=2)+
  annotate(geom="text", x = 0.75, y = .5, 
           label="Radial Distance = 1 m", angle=90,
           colour = "black")

#Write .csv
setwd("~/Desktop/PC_Folders/LHB/Manuscripts/GPS_Calibration/GPS_Data_Processing")
write.csv(EWSN_R,file="Roaming_Point_Survey.csv")

#######################################

