############################################
#### Andrew Osborne #### Sept 2024 ####
#### Tests for asymetry of distribution ####
############################################
options(digits=14)
options(scipen=999)

rad2deg <- function(rad) {(rad * 180) / (pi)}

setwd("~/Desktop/PC_Folders/LHB/Manuscripts/GPS_Calibration/GPSCalibration_SupplementalData")
#Data files from the three Surveys
list.files(pattern=".csv")


#from Trimble data using Wilton-Jones transformation
x= -2.4748789803808
y= 53.450914719012

####Fixed Base-station Survey####
EWSN_F <-read.csv("Fixed_BaseStation_Survey.csv")

##BES
BES_F <-subset(EWSN_F, Receiver=="BES")
mean(BES_F$Dist)
median(BES_F$Dist)
#longitude
shapiro.test(BES_F$lon)#significantly different from normal
boxplot(BES_F$lon, horizontal =TRUE, ylab="BES Longitude",cex.lab=1.3)
abline(v=x,col="red")
abline(v=mean(BES_F$lon),col="green")
?wilcox.test
wilcox.test(BES_F$lon,mu=x)#measurements of longitude significantly different from datum
#latitude
shapiro.test(BES_F$lat)#significantly different from normal
boxplot(BES_F$lat, horizontal =FALSE, ylab="BES Latitude",cex.lab=1.3)
abline(h=y,col="red")
wilcox.test(BES_F$lat,mu=y)#measurements of longitude significantly different from datum
# bias in distance measurement
#lon
mean(BES_F$lon);x
(mean(BES_F$lon)-x)/0.0000151#West 0.2472m
BES_F.x <-(mean(BES_F$lon)-x)/0.0000151
#lat
mean(BES_F$lat);y
(mean(BES_F$lat)-y)/0.000009#North 0.0261m
BES_F.y <-(mean(BES_F$lat)-y)/0.000009
#angle
rad2deg(atan(BES_F.y/0.2472))#6.03degrees north of west
#Bearing
270+6.03#276.0degrees
#Distance
sqrt(0.2472^2+0.261^2)#mean bias

####

##BELC
BELC_F <-subset(EWSN_F, Receiver=="BELC")
#longitude
shapiro.test(BELC_F$lon)#significantly different from normal
boxplot(BELC_F$lon, horizontal =TRUE, ylab="BELC Longitude",cex.lab=1.3)
abline(v=x,col="red")
wilcox.test(BELC_F$lon,mu=x)#measurements of longitude significantly different from datum
#latitude
shapiro.test(BELC_F$lat)#significantly different from normal
boxplot(BELC_F$lat, horizontal =FALSE, ylab="BELC Latitude",cex.lab=1.3)
abline(h=y,col="red")
wilcox.test(BELC_F$lat,mu=y)#measurements of longitude significantly different from datum

# bias in distance measurement
#lon
mean(BELC_F$lon);x
(mean(BELC_F$lon)-x)/0.0000151#East 0.2735
BELC_F.x <-(mean(BELC_F$lon)-x)/0.0000151
#lat
mean(BELC_F$lat);y
(mean(BELC_F$lat)-y)/0.000009#North 1.3367
BELC_F.y <-(mean(BELC_F$lat)-y)/0.000009
#angle
rad2deg(atan(BELC_F.y/BELC_F.x))#78degees north of east
#Bearing 
90-78#12degrees
#Distance
sqrt(0.2735^2+1.3367^2)
####

##iP6
iP6_F <-subset(EWSN_F, Receiver=="iP6")
#longitude
shapiro.test(iP6_F$lon)#significantly different from normal
boxplot(iP6_F$lon, horizontal =TRUE, ylab="iP6 Longitude",cex.lab=1.3)
abline(v=x,col="red")
wilcox.test(iP6_F$lon,mu=x)#measurements of longitude significantly different from datum
#latitude
shapiro.test(iP6_F$lat)#significantly different from normal
boxplot(iP6_F$lat, horizontal =FALSE, ylab="iP6 Latitude",cex.lab=1.3)
abline(h=y,col="red")
wilcox.test(iP6_F$lat,mu=y)#measurements of longitude significantly different from datum

# bias in distance measurement
#lon
mean(iP6_F$lon);x
(mean(iP6_F$lon)-x)/0.0000151#East 1.674m
iP6_F.x <-(mean(iP6_F$lon)-x)/0.0000151
#lat
mean(iP6_F$lat);y
(mean(iP6_F$lat)-y)/0.000009#South 0.7005m
iP6_F.y <-0.7005
#angle
atan(iP6_F.y/iP6_F.x)#0.3963rad
rad2deg(atan(iP6_F.y/iP6_F.x))#23degrees south of east
#Bearing
90+23#113degrees
#Distance
sqrt(1.674^2+0.7005^2)
####

##iP12
iP12_F <-subset(EWSN_F, Receiver=="iP12")
head(iP12_F)
#longitude
shapiro.test(iP12_F$lon)#significantly different from normal
boxplot(iP12_F$lon, horizontal =TRUE, ylab="iP12 Longitude",cex.lab=1.3)
abline(v=x,col="red")
wilcox.test(iP12_F$lon,mu=x)#measurements of longitude significantly different from datum
#latitude
shapiro.test(iP12_F$lat)#significantly different from normal
boxplot(iP12_F$lat, horizontal =FALSE, ylab="iP12 Latitude",cex.lab=1.3)
abline(h=y,col="red")
wilcox.test(iP12_F$lat,mu=y)#measurements of longitude significantly different from datum
# bias in distance measurement
#lon
mean(iP12_F$lon);x
(mean(iP12_F$lon)-x)/0.0000151 #East 0.9527m
iP12_F.x <-(mean(iP12_F$lon)-x)/0.0000151
#lat
mean(iP12_F$lat);y
(mean(iP12_F$lat)-y)/0.000009#North 0.3101m
iP12_F.y <-(mean(iP12_F$lat)-y)/0.000009
#angle
atan(iP12_F.y/iP12_F.x)#0.314 rad
rad2deg(atan(iP12_F.y/iP12_F.x))#18.03 deg north of east
#Bearing
90-18.02# 72 degrees
#Distance
sqrt(0.9527^2+0.3101^2)
####
###################################
